<template>
  <el-form ref="form" :model="user" :rules="rules" label-width="80px">
    <el-form-item :label="$t('system.oldPassword')" prop="oldPassword">
      <el-input v-model="user.oldPassword" :placeholder="$t('system.oldPassword1')" type="password" show-password/>
    </el-form-item>
    <el-form-item :label="$t('system.newPassword')" prop="newPassword">
      <el-input v-model="user.newPassword" :placeholder="$t('system.newPassword1')" type="password" show-password/>
    </el-form-item>
    <el-form-item :label="$t('system.confirmPassword')" prop="confirmPassword">
      <el-input v-model="user.confirmPassword" :placeholder="$t('system.confirmPassword1')" type="password" show-password/>
    </el-form-item>
    <el-form-item>
      <el-button type="primary" size="mini" @click="submit">{{$t('system.save')}}</el-button>
      <el-button type="danger" size="mini" @click="close">{{$t('system.close')}}</el-button>
    </el-form-item>
  </el-form>
</template>

<script>
import { updateUserPwd } from "@/api/system/user";

export default {
  data() {
    const equalToPassword = (rule, value, callback) => {
      if (this.user.newPassword !== value) {
        callback(new Error(this.$t('system.equalToPassword')));
      } else {
        callback();
      }
    };
    return {
      user: {
        oldPassword: undefined,
        newPassword: undefined,
        confirmPassword: undefined
      },
      // 表单校验
      rules: {
        oldPassword: [
          { required: true, message: this.$t('system.oldPassword2'), trigger: "blur" }
        ],
        newPassword: [
          { required: true, message: this.$t('system.newPassword2'), trigger: "blur" },
          { min: 6, max: 20, message: this.$t('system.newPassword3'), trigger: "blur" }
        ],
        confirmPassword: [
          { required: true, message: this.$t('system.confirmPassword2'), trigger: "blur" },
          { required: true, validator: equalToPassword, trigger: "blur" }
        ]
      }
    };
  },
  methods: {
    submit() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          updateUserPwd(this.user.oldPassword, this.user.newPassword).then(response => {
            this.$modal.msgSuccess(this.$t('system.msgSuccess'));
          });
        }
      });
    },
    close() {
      this.$tab.closePage();
    }
  }
};
</script>
